<?php
defined('CON_FRAMEWORK') || die('Illegal call: Missing framework initialization - request aborted.');

/* config area */
// which typeid and idtype do we use?
$html = "CMS_HTML[1]";

// which image types will we generate for the picture tag?
$types = array('webp', 'jpeg');

// which settings of image dialog overwrite wich media data settings?
$overwrite = array('alt' => 'description', 'title' => 'medianame');

// parameters we need for rebuilding and other parameters allowed to have in img tags
$parameterNames = array('src', 'alt', 'title', 'class', 'width', 'height', 'style');

if (!cRegistry::isBackendEditMode()) {
	
	/* find the images */
	// pattern in use: <img\s+[^\\>]*\>
	if (preg_match_all('/<img\\s+[^\\\\>]*\\>/i', $html, $arr, PREG_PATTERN_ORDER)) {
		$imgTags = $arr[0];
		//var_dump($imgTags);	
		// find all parameters in each tag, list
		$imageData = array();
		// get template
		$myModul = new cModuleHandler($cCurrentModule);
		$templatePath = $myModul->getTemplatePath('figure.tpl');
		$relTemplatePath = str_replace(cRegistry::getFrontendPath() , '', $templatePath);
		$template = file_get_contents($templatePath);

		/* handle each image */
		foreach($imgTags as $imgTag) {
			// array for all image information
			$new = array();
			// find all parameters
			foreach($parameterNames as $parameterName) {
				$pattern = '/' . $parameterName . '=\\"(.*?)\\"/i';
				if (preg_match_all($pattern, $imgTag, $arr, PREG_SET_ORDER)) {
					if (isset($arr[0][1])) {
						$new[$parameterName] = $arr[0][1];
					}
				}
			}
			
			/* generate image object */
			if (!class_exists('cImage')) {
				cinclude('module', 'class.image.php');
			}
			$im = new cImage($new['src']);

			// get metadata, combine with image data
			$metaData = $im->getMetaData();
			foreach($overwrite as $search => $replace) {
				if (!empty($new[$search])) {
					if ($new[$search] == '-') {
						$new[$search] = '';
					}
					$metaData[$replace] = $new[$search];
				} 
			}
			
			/* built picture tag */
			if (empty($new['width'])) {
				$new['width'] = 0;
			}
			if (empty($new['height'])) {
				$new['height'] = 0;
			}

			// generate new image tag
			// for not replacing a image tag twice, we mark it as a replacement. (We will remove this marking later.)
			$newImgTag = '<img/*REPLACEMENT*/';
			foreach($parameterNames as $parameterName) {
				if (!empty($new[$parameterName]) || $parameterName == 'alt') {
					$newImgTag .= ' ' . $parameterName . '="' . $new[$parameterName] . '"';
				}
			}
			$newImgTag .= '>';

			// generate picure tag if types are listed 
			if (!empty($types) && count($types) > 0) {

				$pictureTag = '<picture>';
				// generate sources type by type
				foreach($types as $type) {
					$pictureTag .= '<source srcset="' . $im->getImage($new['width'], $new['height'], 'cover', $type) . '" type="image/' . $type . '">';
				}
				// add the image tag
				$pictureTag .= $newImgTag;
				$pictureTag .= '</picture>';
				
				$new['img'] = $pictureTag;
			} else {
				$new['img'] = $newImgTag;
			}
			
			// generate whole snippet for replacement
			$replacement = $template;
		
			// insert values from native html code
			foreach($new as $key => $value) {
				if(isset($value)) {
					$replacement = str_replace('{' . strtoupper($key) . '}', $value, $replacement);
				}
			}
			
			// insert values from image meta data
			foreach($metaData as $key => $value) {
				if(isset($value)) {
					$replacement = str_replace('{' . strtoupper($key) . '}', $value, $replacement);
				}
			}
			
			// remove empty tags
			$replacement = preg_replace('/\\{.*?\\}/i', '', $replacement);
			
			$html = str_replace($imgTag, $replacement, $html);
		}
		$html = str_replace('/*REPLACEMENT*/', '', $html);
	}
}
echo $html;




?>